/*
 * Created on 22.09.2004
 */
package bank;


/**
 * @author oliver
 * @since 22.09.2004
 */
public aspect KontoAspect {

    pointcut kontobewegung(double betrag):
        (call(public void bank.Konto.einzahlen(double))
            || call(public void bank.Konto.abheben(double)))
        && args(betrag);

    before(double betrag) : kontobewegung(betrag) {
        if (betrag < 0) {
            throw new IllegalArgumentException("negativer Betrag");
        }
    }

    before(double betrag, Konto konto):
            execution(public void Konto.abheben(double))
            && args(betrag) 
            && this(konto) {
        if (betrag > konto.kontostand) {
            throw new RuntimeException("keine Deckung");
        }
    }

    pointcut kontoMethods():
        call(public * bank.Konto.*(..));
        
    after(): kontoMethods() {
        if (((Konto)thisJoinPoint.getTarget()).kontostand < 0) {
            throw new RuntimeException("Konto ueberzogen");
        }
    }
    
    
    
    /**
     * zusaetzliches Attribut fuer's Konto
     */
    public double bank.Konto.freistellungsbetrag;

}
