/*
 * $Id: KontoAspect.aj,v 1.1 2005/06/24 13:56:06 boehm Exp $
 * (c)reated on 04.10.2004 by oliver
 */
package bank;

/**
 * @author oliver
 * @since 04.10.2004
 * @version $Revision: 1.1 $
 */
public aspect KontoAspect {
    
    pointcut callBankMethods() :
        call(* bank.*Konto.*(*))
        || call(* bank..*Konto.*(..));

    after() : callBankMethods() {
        System.out.println("1 " + thisJoinPoint);
    }
    
    after() : call(java..Date.new(..)) {
        System.out.println("2 " + thisJoinPoint);
    }
    
    after() : call(java.lang.Exception+.new(..)) {
        System.out.println("3 " + thisJoinPoint);
    }
    
    before() : call(* java.io.Writer+.*(..) throws java.io.IOException) {
        System.out.println("4 " + thisJoinPoint);
    }
    
    pointcut accessKontostand() :
        get(private double bank.Konto.kontostand)
        || set(private double bank.Konto.kontostand);
    
    after() : accessKontostand() {
        System.out.println("5 " + thisJoinPoint);
    }
    
    after() : 
            call(public void java.io.PrintStream+.print(String)) 
            && !within(bank..*Test) {
        System.out.println("6 " + thisJoinPoint);
    }
    
    after() : call(public !final * java.io.PrintStream+.*(..))
              && !within(bank..*Test) 
              && !within(KontoAspect) {
        System.out.println("7 " + thisJoinPoint);
    }

}
