/*
 * $Id$
 * (c)reated on 06.10.2004 by oliver
 */
package bank;

import org.aspectj.lang.*;
import org.aspectj.lang.reflect.*;

/**
 * @author oliver
 * @since 06.10.2004
 * @version $Revision$
 */
public aspect KontoAspect {
    
    //  ----  Zugriff auf den Kontext  ----
    
    /**
     * thisJoinPoint-Methoden -- ein Ueberblick
     */
    before() : execution(public void bank.Konto.einzahlen(double)) {
        AspectHelper.printJoinPoint(thisJoinPoint);
    }
    
    /**
     * thisJoinPoint-Methoden im Detail
     */
    before() : execution(public void bank.Konto.einzahlen(double)) {
        System.out.println(thisJoinPoint.toString());
        System.out.println(thisJoinPoint.toShortString());
        System.out.println(thisJoinPoint.toLongString());
        Konto konto = (Konto)thisJoinPoint.getThis();
        System.out.println("this = " + konto);
        konto = (Konto)thisJoinPoint.getTarget();
        System.out.println("target = " + konto);
        Object[] args = thisJoinPoint.getArgs();
        for (int i = 0; i < args.length; i++) {
            System.out.println("argument" + i + " = " + args[i]);
        }
        Signature signature = thisJoinPoint.getSignature();
        System.out.println("signature: " + signature);
        System.out.println("short:     " + signature.toShortString());
        System.out.println("long:      " + signature.toLongString());
        System.out.println("name:      " + signature.getName());
        System.out.println("modifiers: " +
            java.lang.reflect.Modifier.toString(signature.getModifiers()));
        System.out.println("type:      " + signature.getDeclaringType());
        System.out.println("source location: " +
            thisJoinPoint.getSourceLocation());
        SourceLocation sl = thisJoinPoint.getSourceLocation();
        System.out.println("within type " + sl.getWithinType());
        System.out.println(thisJoinPoint.getKind());
        
        System.out.println("--- thisJoinPoint.getStaticPart() ---");
        System.out.println(thisJoinPoint.getStaticPart());
        System.out.println(thisJoinPointStaticPart);
        System.out.println("signature: " 
                + thisJoinPointStaticPart.getSignature());
        System.out.println("location : " 
                + thisJoinPointStaticPart.getSourceLocation());
        System.out.println("kind     : " 
                + thisJoinPointStaticPart.getKind());
        System.out.println("toString : " 
                + thisJoinPointStaticPart.toString());
        System.out.println("short    : " 
                + thisJoinPointStaticPart.toShortString());
        System.out.println("long     : " 
                + thisJoinPointStaticPart.toLongString());
    }
    
    /**
     * Unterschied getThis() / getTarget()
     */
    before() : execution(public void bank.Konto.einzahlen(double)) {
        System.out.println("exec: getThis()   =" + thisJoinPoint.getThis());
        System.out.println("exec: getTarget() =" + thisJoinPoint.getTarget());
    }
    before() : call(public void bank.Konto.einzahlen(double)) {
        System.out.println("call: getThis()   =" + thisJoinPoint.getThis());
        System.out.println("call: getTarget() =" + thisJoinPoint.getTarget());
    }
    
    /**
     * thisJoinPointStaticPart-Methoden
     */
    before() : execution(public void bank.Konto.einzahlen(double)) {
        System.out.println();
        AspectHelper.printStaticJoinPoint(thisJoinPointStaticPart);
    }
    
    /**
     * Signatur ermitteln
     */
    before() : execution(public void bank.Konto.einzahlen(double)) {
        System.out.println();
        AspectHelper.printSignature(thisJoinPoint.getSignature());
    }
    
    /**
     * SourceLocation getSourceLocation()
     */
    before() : execution(public void bank.Konto.einzahlen(double)) {
        System.out.println();
        AspectHelper.printSourceLocation(thisJoinPoint.getSourceLocation());
    }

}
