/*
 * $Id: TracingAspect.aj,v 1.1 2005/06/24 13:56:06 boehm Exp $
 * (c)reated on 11.10.2004 by oliver
 */
package jrequest.admin;

import java.util.regex.*;

/**
 * @author oliver
 * @since 11.10.2004
 * @version $Revision: 1.1 $
 */
public aspect TracingAspect {

    pointcut executeAnyPublicMethod1() :
        execution(public * jrequest.base.*.* (..))
            && if (Tracing.isEnabled());

    pointcut executeAnyPublicMethod2() :
        execution(public * *.* (..))
            && !execution(public * Tracing.isEnabled())
            && if (Tracing.isEnabled());

    pointcut executeAnyPublicMethod3() :
        execution(public * *.* (..))
            && if (Tracing.enabled);

    before() : executeAnyPublicMethod3() {
        System.out.println(thisJoinPoint);
    }

    pointcut callToString() : call(public String toString())
        && this(junit.framework.TestCase)
        && if (Pattern
            .matches(".*Test", thisJoinPoint.getThis().getClass().getName()));

    before() : callToString() {
        System.out.println("toString() called from " + 
                thisJoinPoint.getThis());
    }

}
