/*
 * Created on Dec 18, 2003
 */
package lotto;

import java.util.*;

/**
 * @author oliver
 */
public aspect LogAspect {
    
    pointcut callMixNumbers(int i) :
        call(public void mixNumbers(int)) && args(i);
    
    before(int i) : callMixNumbers(i) {
        Log.info(thisJoinPoint + " arg = " + i);
    }
    
    /////   Erfassen der Argumente   /////
    
    pointcut callMixNumbers2(int min, int max) :
        call(public void mixNumbers(int, int)) && args(min, max);

    before(int min, int max) : callMixNumbers2(min, max) {
        Log.info(thisJoinPoint + " min = " + min + ", max = " + max);
    }
    
//    /////   Verstoesse gegen die Links-Rechts-Regel   /////
//    
//    before(int min, int max) : callMixNumbers2(min) {
//        Log.info(thisJoinPoint + " min = " + min);
//    }
//
//    before(int min, int max) : callMixNumbers2(max, min) {
//        Log.info(thisJoinPoint + " min = " + min + ", max = " + max);
//    }
//
//    pointcut callMixNumbers1or2(int min, int max) :
//        call(public void mixNumbers(int, int)) && args(min, max)
//        || call(public void mixNumbers(int)) && args(min);

    /////   Parameter-Aenderungen sind nur lokal   /////
    
    before(int min, int max) : callMixNumbers2(min, max) {
        Log.info("mixNumbers(..): min = " + min + ", max = " + max);
        min = -1;
    }

    after(int min, int max) : callMixNumbers2(min, max) {
        Log.info("after: min = " + min + ", max = " + max);
    }

    pointcut callMixNumbers3(int min, int max, Random random) :
        call(public void mixNumbers(int, int, Random))
            && args(min, max, random);

    before(int min, int max, Random random) :
            callMixNumbers3(min, max, random) {
        Log.info("mixNumbers(..): min = " + min + ", max = " + max
                 + ", " + random);
    }

}
