/*
 * Created on Dec 29, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package toolbox;

import java.io.IOException;

import org.apache.log4j.*;

/**
 * Log
 * 
 * @author oliver
 * @since  Dec 29, 2003
 */
public class Log {
    
    private static Logger logger = null;
    private static Logger profileLogger = null;
    
    static {
        init();
    }
    
    public static void init() {
        if (logger == null) {
            logger = initLogger("Lotto.log", "%3r %-5p- %m\n");
        }
        if (profileLogger == null) {
            profileLogger = initLogger("Profiling.log","%d{HH:mm:ss,SSS} %m\n");
        }
    }
    
    private static Logger initLogger(String filename, String pattern) {
        Logger logger = Logger.getLogger(filename);
        try {
            Appender appender =
                new FileAppender(new PatternLayout(pattern),
                    filename, false);
            logger.addAppender(appender);
            System.out.println("Protokollierung: " + filename);
        } catch (IOException e) {
            BasicConfigurator.configure();
        }
        return logger;
    }
    
    public static void info(String msg) {
        logger.info(msg);
    }
    
    public static void error(String msg) {
        logger.error("*** " + msg);
    }
    
    public static void error(String msg, Throwable t) {
        logger.error("*** " + msg, t);
    }
    
    public static void profile(String msg) {
        profileLogger.info(msg);
    }

}
