/*
 * Created on Feb 24, 2004
 */
package lotto;

import java.io.*;
import java.util.*;

/**
 * @author oliver (boehm@javatux.de)
 */
public class Ziehung {

    //int[] zahl = new int[6];
    int[] zahl = { 1, 2, 3, 4, 5, 6 };
    int zusatzzahl = 7;

    public int[] getZahlen() {
        return zahl;
    }

    /**
     * Die Ziehung der Lottozahlen beginnt...
     */
    public void start() {
        this.start(new Trommel());
    }
    
    public void start(Trommel trommel) {
        for (int i = 0; i < 6; i++) {
            zahl[i] = zieheZahl(trommel);
        }
        this.sort();
        zieheZusatzzahl(trommel);
    }

    public void zieheZusatzzahl(Trommel trommel) {
        zusatzzahl = zieheZahl(trommel);
    }
    
    private int zieheZahl(Trommel trommel) {
        //trommel.mixNumbers();
        return trommel.getNumber().intValue();
    }
    
    /**
     * Sortiert die Zahlen mittels Bubblesort.
     */
    private void sort() {
        boolean sorted = false;
        while (!sorted) {
            sorted = true;
            for (int i = 0; i < 5; i++) {
                if (zahl[i] > zahl[i+1]) {
                    sorted = false;
                    int tmp = zahl[i];
                    zahl[i] = zahl[i+1];
                    zahl[i+1] = tmp;
                }
            }
        }
    }
    
    public List getWinners() throws FileNotFoundException, IOException {
        return getWinners("Lotto.schein");
    }
    
    public List getWinners(String filename) 
            throws FileNotFoundException, IOException {
        List winners;
        Reader reader = new FileReader(filename);
        winners = getWinners(reader);
        //reader.close();
        return winners;
    }
//    public List getWinners(String filename) {
//        List winners;
//        try {
//            Reader reader = new FileReader(filename);
//            winners = getWinners(reader);
//            //reader.close();
//            return winners;
//        } catch (FileNotFoundException e) {
//            return null;
//        } catch (IOException e) {
//            return null;
//        }
//    }

    public List getWinners(Reader reader) throws IOException {
        List winners = new Vector();
        try {
            while (reader.ready()) {
                Schein schein = new Schein();
                schein.read(reader);
                if (schein.getNoRichtige(zahl) >= 3) {
                    winners.add(schein);
                }
            }
        } catch (EOFException expected) {}
        return winners;
    }
    
    public String toString() {
        return "" + zahl[0] + " " + zahl[1] + " " + zahl[2] + " "
            + zahl[3] + " " + zahl[4] + " " + zahl[5]
            + " Zusatzzahl " + zusatzzahl;
    }
    
    public String toShortString() {
        return "" + zahl[0] + " " + zahl[1] + " " + zahl[2] + " "
            + zahl[3] + " " + zahl[4] + " " + zahl[5]
            + " " + zusatzzahl;
    }
    
    public static void main(String[] args)
            throws FileNotFoundException, IOException {
//        System.out.println("Start der Ziehungen:");
//        for (char c = 'A'; c <= 'z'; c++) {
//            Ziehung ziehung = new Ziehung();
//            ziehung.start();
//            System.out.println("" + c + "\t" + ziehung);
//        }
        Ziehung ziehung = new Ziehung();
        ziehung.start();
//        System.out.println(System.getProperty("welcome.message"));
        String msg = System.getProperty("welcome.message");
        if (msg == null) {
            System.out.println("Willkommen zur Lotto-Ziehung");
        } else {
            System.out.println(msg);
        }
        System.out.println(111111);
        System.out.println("Ziehung: " + ziehung);
        List winners = ziehung.getWinners();
        for (Iterator i = winners.iterator(); i.hasNext();) {
            Schein schein = (Schein) i.next();
            System.out.println(schein.getSpieler() + "\t: "
                + schein.getNoRichtige(ziehung.getZahlen()) + " Richtige ("
                + schein + ")"); 
        }
    }

}
