/*
 * $Id: LogAspect.aj,v 1.1 2005/06/24 13:56:04 boehm Exp $
 * (c)reated on 13.10.2004 by oliver
 */
package bank;

import java.io.*;

/**
 * @author oliver
 * @since 13.10.2004
 * @version $Revision: 1.1 $
 */
public aspect LogAspect {

    pointcut setAttribute(Object newValue) :
        set(* Konto.*) && args(newValue);
        
    before(Object newValue) : setAttribute(newValue) {
        System.out.println(thisJoinPoint + " set to " + newValue);
    }

    before(Object newValue) : setAttribute(newValue) {
        System.out.println(thisJoinPoint + " set to " + newValue
                           + " ("+ newValue.getClass() +")");
    }
    
    // hier funktioniert Autoboxing nur mit Java5
    before(Double betrag) : set(double Konto.kontostand) && args(betrag) {
        System.out.println("neuer Kontostand: " + betrag);
    }

    /////   Zugriff ueber Reflexion   /////
    
    before() : set(* Konto.*) {
        Object[] values = thisJoinPoint.getArgs();
        System.out.println(thisJoinPoint + " set to " + values[0]);
    }

    /////   nur 1. und letzten Parameter protokollieren   /////
    
    before(Object first, Object last) :
            call(public void *(..))
            && args(first, *, last) {
        System.out.println("ARGS = " + first + "..."
                + last + " for " + thisJoinPoint);
    }
    
    /////   Was macht dieser Advice?   /////
    
    after(): execution(public void Konto.abheben(double)) {
        Konto konto = (Konto) thisJoinPoint.getThis();
        Double betrag = (Double) thisJoinPoint.getArgs()[0];
        double gebuehr = betrag.doubleValue() * 0.005;
        System.out.println("Betrag: " + betrag + "\tGebuehr1: " + gebuehr);
        konto.kontostand -= gebuehr;
    }

    /////   und dieser Advice?   /////

    after(double betrag, Konto konto):
            execution(public void Konto.abheben(double))
            && args(betrag)
            && this(konto) {
        // kleiner Obulus fuer die Bank einbehalten
        double gebuehr = betrag * 0.005;
        System.out.println("Betrag: " + betrag + "\tGebuehr2: " + gebuehr);
        konto.kontostand -= gebuehr;
    }
    
    /////   Advices und Exceptions   /////
    
    after(double betrag, Konto empfaenger) : 
            execution(public void Konto.ueberweisen(double, Konto))
            && args(betrag, empfaenger) {
        String msg = "Ueberweisung " + betrag + " auf " + empfaenger;
        try {
            FileWriter writer = new FileWriter("ueberweisung.log", true);
            writer.write(msg + "\n");
            writer.close();
        } catch (IOException e) {
            System.out.println("msg");
        }
    }

}
