/*
 * $Id: TrommelAspect.aj,v 1.1 2005/06/24 13:56:07 boehm Exp $
 * (c)reated on 15.10.2004 by oliver
 */
package lotto;


/**
 * @author oliver
 * @since 15.10.2004
 * @version $Revision: 1.1 $
 */
public aspect TrommelAspect {
    
    pointcut callMixNumbers() :
        call(public void Trommel.mixNumbers(..));

    void around() : callMixNumbers() {
        proceed();
        proceed();
    }
    
    void around() : execution(public void Trommel.mixNumbers()) {
        proceed();
    }

    pointcut executeMixNumbers(Trommel trommel) :
        execution(public void Trommel.mixNumbers())
        && this(trommel);

    void around(Trommel trommel) : executeMixNumbers(trommel) {
        do {
            //proceed();        // geht nicht, AspectJ erwartet hier einen Parameter
            proceed(trommel);   // jetzt mit Paramter!
        } while (!trommel.isMixed());
    }
    
    pointcut executeMixNumbers2(Trommel trommel, int n) :
        execution(public void Trommel.mixNumbers(int))
        && this(trommel)
        && args(n);

    void around(Trommel trommel, int n) : executeMixNumbers2(trommel, n) {
        do {
            proceed(trommel, n);          // jetzt sind 2 Parameter n�tig
        } while (!trommel.isMixed());
    }

}
