/*
 * $Id: LogAspect.aj,v 1.2 2005/07/22 11:56:09 boehm Exp $
 * (c)reated on 14.10.2004 by oliver
 */
package toolbox;

import java.io.*;
import java.util.*;
import java.text.*;

import lotto.*;

/**
 * @author oliver
 * @since 14.10.2004
 * @version $Revision: 1.2 $
 */
public aspect LogAspect {

    /////   unqualifizierter Advice   /////
    
    pointcut executeGetWinners(String s) :
        execution(public List Ziehung.getWinners(String))
        && args(s);

    after(String s) : executeGetWinners(s) {
        Log.info("Gewinner wurden aus <" + s + "> ermittelt.");
    }

    /////   Auswertung des Rückgabewerts   /////
    
    after(String s) returning(List l): executeGetWinners(s) {
        Log.info("Liste der Gewinner: ");
        for (Iterator i = l.iterator(); i.hasNext();) {
            Schein schein = (Schein) i.next();
            Log.info("xxxxxx  " + schein.getSpieler());
        }
    }
    
    after() returning(Object o) : execution(public * Trommel.*(..)) {
        Log.info(thisJoinPoint +  " returns " + o);
    }

    /////   After Returning   /////

    after(String s) returning: executeGetWinners(s) {
        Log.info("Gewinner wurden aus <" + s + "> erfolgreich ermittelt.");
    }
    
    /////   After Throwing   /////
    
    after(String s) throwing : executeGetWinners(s) {
        Log.error("Fehler in " + thisJoinPoint);
        Log.error(s + " konnte nicht gelesen werden!");
    }

    after(String s) throwing (IOException e): executeGetWinners(s) {
        Log.error("Fehler in " + thisJoinPoint, e);
        Log.error(s + " konnte nicht gelesen werden!");
    }
    
    after(String s) throwing (ParseException e): executeGetWinners(s) {
        Log.info("Dieser Advice trägt die falsche Exception");
    }

    /*
     * Log.info-Calls um weitere Infos erweitern...
     */

    public pointcut callLogInfo(String msg) :
        call(public void Log.info(String)) &&
        args(msg);

    void around(String msg) : callLogInfo(msg) {
        String extended = thisJoinPointStaticPart.getSourceLocation()
            + ": " + msg;
        proceed(extended);
    }

    /*
     * leerer Pointcut
     * (auf System.out laesst sich kein Pointcut definieren)
     */ 
    public pointcut callSystemOutPrintlnEmpty(Object msg) :
        call(public void java.lang.System.out.println(*)) &&
        args(msg);

    /*
     * Pointcut auf PrintStream-Klasse statt System.out
     */
    public pointcut callSystemOutPrintln(String msg) :
        call(public void java.io.PrintStream.println(*)) &&
        args(msg);
    
    void around(Object msg) : callSystemOutPrintln(msg) {
        if (new Random().nextInt(10) == 0) {
            proceed ("*** " + msg + " ***\n"
                + "Diese Ausgabe wurde ihnen präsentiert von: "
                + "JavaTux.de");
        } else {
            proceed(msg);
        }
    }

}
