/*
 * Created on Feb 24, 2004
 */
package lotto;

import java.io.*;
import java.util.*;

/**
 * @author oliver (boehm@javatux.de)
 */
public class Ziehung {

    protected int[] zahl = { 1, 2, 3, 4, 5, 6 };
    protected Trommel trommel = null;

    public int[] getZahlen() {
        return zahl;
    }

    /**
     * Die Ziehung der Lottozahlen beginnt...
     */
    public void start() {
        trommel = new Trommel();
        for (int i = 0; i < 6; i++) {
            zahl[i] = zieheZahl(trommel);
        }
    }

    private int zieheZahl(Trommel trommel) {
        return trommel.getNumber().intValue();
    }
    public List getWinners() throws FileNotFoundException, IOException {
        return getWinners("Lotto.schein");
    }
    
    public List getWinners(String filename)  throws IOException {
        List winners;
        Reader reader = new FileReader(filename);
        winners = getWinners(reader);
        reader.close();
        return winners;
    }

    public List getWinners(Reader reader) throws IOException {
        List winners = new Vector();
        try {
            while (reader.ready()) {
                Schein schein = new Schein();
                schein.read(reader);
                if (schein.getNoRichtige(zahl) >= 3) {
                    winners.add(schein);
                }
            }
        } catch (EOFException expected) {}
        return winners;
    }

    public String toString() {
        return "" + zahl[0] + " " + zahl[1] + " " + zahl[2] + " "
            + zahl[3] + " " + zahl[4] + " " + zahl[5];
    }

    public static void main(String[] args) {
        Ziehung ziehung = new Ziehung();
        ziehung.start();
        System.out.println("Ziehung: " + ziehung);
    }

}