/*
 * Created on Dec 7, 2003
 */
package bank.test;

import bank.Konto;
import junit.framework.TestCase;

/**
 * @author oliver
 */
public class KontoTest extends TestCase {

    private Konto konto;

	/**
	 * Constructor for KontoTest.
	 * @param arg0
	 */
	public KontoTest(String arg0) {
		super(arg0);
	}

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        konto = new Konto(815, "Max Mustermann");
        super.setUp();
    }
    
//    protected void tearDown() throws Exception {
//        konto.delete();
//    }

    public void testAbfragen() {
        assertEquals(0.0, konto.abfragen(), 0.005);
    }

    public void testEinzahlen() {
        konto.einzahlen(1.23);
        assertEquals(1.23, konto.abfragen(), 0.005);
    }
    
    public void testAbheben() {
        konto.einzahlen(4.50);
        konto.abheben(3.45);
        assertEquals(1.05, konto.abfragen(), 0.02);
    }

    public void testUeberweisen() {
        Konto schwarzgeldKonto = new Konto(4711, "Bernd Birne");
        konto.einzahlen(5000.00);
        konto.ueberweisen(1000.00, schwarzgeldKonto);
        assertEquals(4000.00, konto.abfragen(), 6.0);   // evtl. Gebuehr!
        assertEquals(1000.00, schwarzgeldKonto.abfragen(), 0.005);
    }
    
    public static void main(String args[]) {
        junit.swingui.TestRunner.run(KontoTest.class);
    }

}
