/*
 * Created on 05.03.2005
 *
 * $Id: PassengerTest.java,v 1.1 2005/06/24 13:56:05 boehm Exp $
 */
package space.test;

import junit.framework.TestCase;
import space.Passenger;
import space.annotation.Test;
import space.inhabitant.*;

@Test
public class PassengerTest extends TestCase {
    
    private Passenger passenger = null;

    public static void main(String[] args) {
        junit.textui.TestRunner.run(PassengerTest.class);
    }

    protected void setUp() throws Exception {
        passenger = new Passenger("Theo Tester");
    }

    /*
     * Class under test for void Passenger()
     */
    public void testPassenger() {
        assertNotNull(passenger);
    }
    
    public void testAliens() {
        passenger = new Klingon("K. Lin Gon");
        testPassenger();
        passenger = new Martian("M. Ars");
        testPassenger();
    }
    
    public void testHuman() {
        passenger = new Earthling("Oli B.");
        testPassenger();
    }
    
    public void testGetName() {
        assertEquals("Theo Tester", passenger.getName());
    }
    
    public void testGetFirstName() {
        assertEquals("Theo", passenger.getFirstName());
    }

    /*
     * Class under test for String toString()
     */
    public void testToString() {
        assertTrue(passenger.toString().endsWith("Theo Tester"));
    }

}
