/*
 * Created on Jul 7, 2004
 */
package verwaltung.log;


import org.aspectj.lang.annotation.*;
import org.aspectj.lang.*;

import verwaltung.*;


/**
 * @author oliver
 * @since Jul 7, 2004
 */
//public aspect PersonLoggingAspekt extends AbstraktLoggingAspekt 
//    issingleton() {
@Aspect("issingleton()")
public class PersonLoggingAspekt extends AbstraktLoggingAspekt {

    public String getModulname() {
        return "Mitgliedermodul";
    }

    @Pointcut("execution(public verwaltung.Person.new(..))")
    void criticalMethods() {}
//    pointcut criticalMethods() :
//        execution(public Person.new(..));
    
    @Pointcut("call(void *..setName(String)) && args(s) && target(callee)")
    void callSetName(String s, Object callee) {}
    
    @Pointcut("call(void *..set*(*)) && args(arg) && if()")
    public static boolean invalidCall(Object arg) {
    	return arg == null;
    }

    @Before("execution(void *..*.run())")
    public void logRun() {
        log("running run()");
    }
//    before() : execution(void *..*.run()) {
//        log("running run()");
//    }

    @After("call(void *..*.*(..)) && this(p)")
    public void calledFromPerson(Person p) {
        log("called from " + p);
    }
//    after(Person p) : call(void *..*.*(..)) && this(p) {
//        log("called from " + p);
//    }


    @After("call(void *..*.*(..)) && this(p)")
    public void calledFromPerson(Person p, JoinPoint thisJoinPoint) {
        log("called from " + p + " -> " + thisJoinPoint);
    }
    
    @AfterReturning(value="call(* verwaltung.Person.get*())",
            returning="obj")
    public void callGetter(Object obj, JoinPoint thisJoinPoint) {
        log(thisJoinPoint + " = " + obj);
    }
//    after() returning(Object obj) : call(* verwaltung.Person.get*())
//            && !within(PersonLoggingAspekt) {
//        log(thisJoinPoint + " = " + obj);
//    }

    @Around("execution(void verwaltung.*.*())")
    public Object doNix(ProceedingJoinPoint thisJoinPoint) {
        log(">>> " + thisJoinPoint);
        return thisJoinPoint.proceed();
    }
//    Object around() : execution(* verwaltung.*.*()) {
//        return proceed();
//    }

    @Around("execution(void verwaltung.Person.setName(String))"
            + " && args(name) && this(p)")
    public void watchSetName(ProceedingJoinPoint thisJoinPoint,
            String name, Person p) {
        Object args[] = { name, p };
        if (p.getName() == null) {
            thisJoinPoint.proceed(args);
        } else {
            System.err.println("Hey, so einfach kann der Name '"
                    + p.getName() + "' nicht auf '" + name
                    + "' gewechselt werden!");
        }        
    }
//    void around(String name, Person p)
//            : execution(void verwaltung.Person.setName(String))
//            && args(name) && this(p) {
//        if (p.getName() == null) {
//            proceed(name, p);
//        } else {
//            System.err.println("Hey, so einfach kann der Name '" + p.getName() 
//                    + "' nicht auf '" + name + "' gewechselt werden!");
//        }
//    }

}
