/*
 * Created on 22.09.2004
 */
package bank;

/**
 * Ein einfaches Bankkonto
 * @author oliver
 * @since 22.09.2004
 */
public class Konto implements Comparable<Konto> {

    protected int kontonummer;
    protected String inhaber;
    protected double kontostand = 0.0;

    public Konto(int kontonr, String inhaber) {
        this.kontonummer = kontonr;
        this.inhaber     = inhaber;
        this.kontostand  = 0.0;
    }

    public double abfragen() {
        return kontostand;
    }
    
    public void einzahlen(double betrag) {
        kontostand = kontostand + betrag;
    }

    public void abheben(double betrag) {
        kontostand = kontostand - betrag;
    }

    public void ueberweisen(double betrag, Konto anderesKonto) {
        this.abheben(betrag);
        anderesKonto.einzahlen(betrag);
    }
    
    /**
     * Signatur ohne Generics: public int compareTo(Object obj)
     * Signatur mit  Generics: public int compareTo(Konto obj)
     */
//    public int compareTo(Object obj) {
//        Konto other = (Konto) obj;
//        double diff = this.kontostand - other.kontostand;
//        return (int) diff;
//    }

    public int compareTo(Konto obj) {
        Konto other = (Konto) obj;
        double diff = this.kontostand - other.kontostand;
        return (int) diff;
    }


}
