/*
 * Created on Jul 7, 2004
 */
package verwaltung.log;
import verwaltung.*;


/**
 * @author oliver
 * @since Jul 7, 2004
 */
public aspect PersonLoggingAspekt extends AbstraktLoggingAspekt 
    issingleton() {
    
//  @Pointcut("execution(public Person.new(..))")
//  void protected criticalMethods() {}
    protected pointcut criticalMethods() :
        execution(public Person.new(..));
    
    public String getModulname() {
        return "Mitgliedermodul";
    }
 
//    @Before("execution(void *..*.run())")
//    public void logRun() {
//        log("running run()");
//    }
    before() : execution(void *..*.run()) {
        log("running run()");
    }
    
//    @After("call(void *..*.*(..)) && this(p)")
//    public void calledFromPerson(Person p) {
//        log("called from " + p);
//    }
    after(Person p) : call(void *..*.*(..)) && this(p) {
        log("called from " + p);
    }
    
//    @After("call(void *..*.*(..)) && this(p)")
//    public void calledFromPerson(JoinPoint thisJoinPoint, Person p) {
//        log("called from " + p + " -> " + thisJoinPoint);
//    }

    after() returning(Object obj) : call(* verwaltung.Person.get*())
            && !within(PersonLoggingAspekt) {
        log(thisJoinPoint + " = " + obj);
    }
    
//  @Around("execution(void verwaltung.*.*())")
//  public Object doNix(ProceedingJoinPoint thisJoinPoint) {
//      return thisJoinPoint.proceed();
//  }
    Object around() : execution(* verwaltung.*.*()) {
        return proceed();
    }
    
//    @Around("execution(void verwaltung.Person.setName(String)) && args(name) && this(p)")
//    public void watchSetName(String name, Person p) {
//        if (p.getName() == null) {
//            proceed(name, p);
//        } else {
//            System.err.println("Hey, so einfach kann der Name '" + p.getName() 
//                    + "' nicht auf '" + name + "' gewechselt werden!");
//        }        
//    }
    void around(String name, Person p)
            : execution(void verwaltung.Person.setName(String))
            && args(name) && this(p) {
        if (p.getName() == null) {
            proceed(name, p);
        } else {
            System.err.println("Hey, so einfach kann der Name '" + p.getName() 
                    + "' nicht auf '" + name + "' gewechselt werden!");
        }
    }
    
}
