/*
 * Created on Aug 6, 2003
 */
package hello;

/**
 * This aspect prints a short message before the actual main method
 * is called.
 * 
 * @author oliver
 * @since Aug 8, 2004
 */
aspect WorldAspect {

    /**
     * meet the main method
     */
    public pointcut mainOperation():
        execution(public static void World.main(String[]));
    
    /**
     * Prints a special AOP greeting.
     */
    before(): mainOperation() {
        System.out.println("Hello aspect oriented world!");
    }
    
//    /**
//     * Prints some the secret internals of a Joinpoint
//     */
//    after() : mainOperation() {
//        AspectHelper.printJoinPoint(thisJoinPoint);
//        AspectHelper.printStaticJoinPoint(thisJoinPointStaticPart);
//        AspectHelper.printSignature(thisJoinPoint);
//        AspectHelper.printSourceLocation(thisJoinPoint);
//    }
    
    after() : execution(public void World.printGreeting()) {
        AspectHelper.printJoinPoint(thisJoinPoint);
    }
    
    after() : call(public void World.printGreeting()) {
        AspectHelper.printJoinPoint(thisJoinPoint);
    }
    
}
