/*
 * Created on Nov 27, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package bio.q;

import java.util.Date;
import bio.*;

/**
 * QAspect
 * 
 * @author oliver
 * @since  Nov 27, 2003
 */
public aspect ContractAspect {
    
    /*
     * Precondition: kein Null-Parameter, Datum in der Vergangenheit
     */
    
    pointcut executeConstructorWithParameter(Object obj) :
        execution(public Rhythm.new(Date)) && (args(obj));
    
    before(Object obj) :  executeConstructorWithParameter(obj) {
        if (obj == null) {
            throw new ContractViolation("Null-Parameter nicht erlaubt!");
        }
        if (obj instanceof Date) {
            Date d = (Date) obj;
            Date now = new Date();
            if (d.after(now)) {
                throw new ContractViolation("ungueltiges Datum");
            }
        }
    }
    
    /*
     * Postcondition: positives Alter
     */

    pointcut executeConstrutor(Rhythm rhythm) :
        execution(public Rhythm.new(..)) && this(rhythm);
    
    after(Rhythm rhythm) returning : executeConstrutor(rhythm) {
        if (rhythm.getAgeInDays() < 0) {
            throw new ContractViolation("negatives Alter");
        }
    }
    
    
    
    /*
     * Postcondition fuer getEmotional(), getMental() und getPhysical():
     * Werte liegen zwischen -100 und +100
     */
    
    pointcut prozentrechnung() : execution(public int Rhythm.getEmotional())
        || execution(public int Rhythm.getMental())
        || execution(public int Rhythm.getPhysical());
    
    after() returning(int n) : prozentrechnung() {
        if ((n < -100) || (n > 100)) {
            throw new ContractViolation("ungltiger Rckgabewert: " + n);
        }
    }

}
