/*
 * Created on Nov 25, 2003
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package bio;

import java.text.ParseException;
import java.util.*;

import junit.framework.AssertionFailedError;
import junit.framework.TestCase;

/**
 * RhythmTest
 * 
 * @author oliver
 * @since  Nov 25, 2003
 */
public class RhythmTest extends TestCase {

    private Date yesterday;

    public static void main(String[] args) {
        junit.textui.TestRunner.run(RhythmTest.class);
    }
    
    public void setUp() throws Exception {
        super.setUp();
        yesterday = getYesterday();
    }

    /*
     * Test for void Rhythm(Date)
     */
    final public void testRhythmDate() {
        Rhythm rhythm = new Rhythm(new Date());
        assertEquals(0, rhythm.getEmotional());
        assertEquals(0, rhythm.getMental());
        assertEquals(0, rhythm.getPhysical());
    }
    
    final public void testGetAgeInDays() {
        Rhythm rhythm = new Rhythm(getYesterday());
        assertEquals(1.0, rhythm.getAgeInDays(), 0.1);
    }

    final public void testGetEmotional() {
        Rhythm rhythm = new Rhythm(yesterday);
        assertEquals(19, rhythm.getEmotional());
    }

    final public void testGetMental() {
        Rhythm rhythm = new Rhythm(yesterday);
        assertEquals(27, rhythm.getMental());
    }

    final public void testGetPhysical() {
        Rhythm rhythm = new Rhythm(yesterday);
        assertEquals(22, rhythm.getPhysical());
    }

    final public void testHashCode() throws ParseException {
        Rhythm r1 = new Rhythm("25.11.2003");
        Rhythm r2 = new Rhythm("25.11.2003");
        assertEquals(r1.hashCode(), r2.hashCode());
    }

    final public void testEquals() throws ParseException {
        Rhythm r1 = new Rhythm("25.11.2003");
        Rhythm r2 = new Rhythm("25.11.2003");
        assertEquals(r1, r2);
        Rhythm r3 = new Rhythm("24.11.2003");
        assertFalse(r3.equals(r1));
    }
    
    final public void testNullStringParameter() throws ParseException {
        try {
            new Rhythm((String) null);
            fail("Wo bleibt die Exception?");
        } catch (RuntimeException expected) {}
    }
    
    final public void testNullDateParameter() {
        try {
            new Rhythm((Date) null);
            fail("Wo bleibt die Exception?");
        } catch (RuntimeException expected) {}
    }
    
    final public void testFutureDate() {
        /*
         * Sinnlos, hier den erwarteten AssertionError abzufangen, da er von
         * Error abgeleitet ist, das einen nicht behebaren Fehler darstellt.
         */
        try {
            new Rhythm(getTomorrow());
            fail("Wo bleibt die Exception?");
        } catch (AssertionFailedError expected) {
        } catch (bio.q.ContractViolation expected) {
        }
    }
    
    static private Date getYesterday() {
        return getDay(-1);
    }
    
    static private Date getTomorrow() {
        return getDay(+1);
    }

    static private Date getDay(int n) {
        Calendar day = new GregorianCalendar();
        day.add(Calendar.DATE, n);
        return day.getTime();
    }
}
