/*
 * Created on 22.07.2004
 */
package test;

import junit.framework.TestCase;

/**
 * @author oliver
 * @since 22.07.2004
 */
public class ObjectTest extends TestCase {
    
    private Object object = null;

    public static void main(String[] args) {
        junit.textui.TestRunner.run(ObjectTest.class);
    }

    /*
     * @see TestCase#setUp()
     */
    protected void setUp() throws Exception {
        super.setUp();
        object = new Object();
    }

    /*
     * @see TestCase#tearDown()
     */
    protected void tearDown() throws Exception {
        super.tearDown();
        object = null;
    }

    /**
     * Constructor for ObjectTest.
     * @param arg0
     */
    public ObjectTest(String arg0) {
        super(arg0);
    }

    public final void testObject() {
        assertNotNull(object);
    }

    public final void testEquals() {
        Object obj2 = object;
        assertNotNull(obj2);
        assertEquals(object, obj2);
        assertEquals(object.hashCode(), obj2.hashCode());
    }

    public final void testToString() {
        for (int i = 0; i < 2000; i++) {
            String s1 = object.toString();
            assertNotNull(s1);
            assertTrue(s1.startsWith("java.lang.Object@"));
            Object obj2 = object;
            String s2 = obj2.toString();
            assertEquals(s1, s2);
        }
    }

}
