/*
 * Created on 07.04.2005
 *
 * $Id: SubjectObserverSet.java,v 1.1 2005/06/24 13:56:07 boehm Exp $
 */
package pattern.observer;

import java.util.*;

/**
 * This class is only a wrapper for a Set because AspectJ 1.5.0M2 seems
 * to have some problems with generics.
 * 
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 07.04.2005
 * @version $revision$
 */
public class SubjectObserverSet {
    
    private Set<SubjectObserver> observers = new HashSet<SubjectObserver>();
    
    public void add(SubjectObserver observer) {
        observers.add(observer);
    }

    public void notifyObservers(Subject observed) {
        for (SubjectObserver observer : observers) {
            observer.update(observed);
        }
    }

}
