/*
 * Created on 04.04.2005
 *
 * $Id: Ampel.java,v 1.1 2005/06/24 13:56:05 boehm Exp $
 */
package verkehrs;

import java.util.Date;

import pattern.observer.*;

public class Ampel implements Subject {
    
    private enum AmpelFarbe { ROT, GRUEN }
    @Observe
    private AmpelFarbe farbe = AmpelFarbe.ROT;

    @Ignore
    private Date start = null;
    
    @Ignore
    public void tick() {
        start = new Date();
    }
    
    @Observe
    public void nextState() {
        System.out.println("\tAmpel springt um von " + farbe);
        if (farbe ==AmpelFarbe.ROT) {
            farbe = AmpelFarbe.GRUEN;
        } else {
            farbe = AmpelFarbe.ROT;
        }
    }

    public boolean isRot() {
        return farbe == AmpelFarbe.ROT;
    }
    
    public boolean isGruen() {
        return farbe == AmpelFarbe.GRUEN;
    }

}
