/*
 * Created on 08.02.2005
 *
 * $Id$
 */
package abrechnung;

import java.io.*;
import java.util.*;

/**
 * @author <a href="mailto:boehm@javatux.de">oliver</a>
 * @since 08.02.2005
 * @version $revision$
 */
public class KaffeeListe implements Cloneable {
    
    protected final static String DATA_FILENAME = "kaffee.liste";
    protected final static String DATA_FILENAME_BAK = "kaffee.bak";
    private Hashtable<String, Integer> kaffeetrinker = new Hashtable<String, Integer>();

    public void addTasse(String name) {
        addTassen(name, 1);
    }
    
    public void addTassen(String name, int anzahl) {
        Integer tassen = getAnzahlTassen(name) + anzahl;
        kaffeetrinker.put(name, tassen);
    }
    
    public void zahleTassen(String name, int anzahl) {
        Integer tassen = getAnzahlTassen(name) - anzahl;
        kaffeetrinker.put(name, tassen);
    }
    
    public void zahleAlleTassen(String name) {
        kaffeetrinker.put(name, 0);
    }
    
    public int getAnzahlTassen(String name) {
        Integer tassen = (Integer) kaffeetrinker.get(name);
        if (tassen == null) {
            return 0;
        } else {
            return tassen;
        }
    }
    
    public Enumeration getKaffeetrinker() {
        return kaffeetrinker.keys();
    }
    
    public void store() throws IOException {
        File file = new File(DATA_FILENAME);
        File backup = new File(DATA_FILENAME_BAK);
        file.renameTo(backup);
        try {
            OutputStream ostream = new FileOutputStream(DATA_FILENAME);
            store(new ObjectOutputStream(ostream));
            ostream.close();
            backup.delete();
        } catch (IOException e) {
            backup.renameTo(file);
            throw new IOException("file reverted");
        }
    }
    
    private void store(ObjectOutputStream oostream) throws IOException {
        oostream.writeObject(this.kaffeetrinker);
    }
    
    public void load() throws IOException {
        InputStream istream = new FileInputStream(DATA_FILENAME);
        load(new ObjectInputStream(istream));
        istream.close();
    }
    
    @SuppressWarnings("unchecked")
    private void load(ObjectInputStream oistream) throws IOException {
        try {
//            this.kaffeetrinker = (Hashtable<String, Integer>) oistream
//                    .readObject();
            // ein schrecklicher Cast - aber immerhin gibt's damit keine Warnung
            this.kaffeetrinker = ((Class<? extends Hashtable<String, Integer>>) (Class) kaffeetrinker
                    .getClass()).cast(oistream.readObject());
        } catch (ClassNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    public String toString() {
        StringBuffer sbuf = new StringBuffer();
        for (Enumeration e = kaffeetrinker.keys(); e.hasMoreElements();) {
            String name = (String) e.nextElement();
            sbuf.append(name + ":" + getAnzahlTassen(name) + " ");
        }
        return sbuf.toString();
    }
    
    public boolean equals(Object other) {
        if (other instanceof KaffeeListe) {
            return this.equals((KaffeeListe) other);
        } else {
            return false;
        }
    }

    public boolean equals(KaffeeListe other) {
        return this.kaffeetrinker.equals(other.kaffeetrinker);
    }
    
    public KaffeeListe clone() {
        KaffeeListe cloned = new KaffeeListe();
        cloned.kaffeetrinker = new Hashtable<String, Integer>(
                this.kaffeetrinker);
        return cloned;
    }

}
