/*
 * Created on 22.09.2004
 */
package bank;

/**
 * Ein einfaches Bankkonto
 * @author oliver
 * @since 22.09.2004
 */
public class Konto {

    public double kontostand = 0.0;
    public String inhaber;

    public Konto(String inhaber) {
        this.inhaber = inhaber;
        kontostand = 0.0;
    }
    
    public Konto(String inhaber, double bonus) {
        this.inhaber = inhaber;
        kontostand = bonus;
    }

    public double abfragen() {
        return kontostand;
    }
    
    public void einzahlen(double betrag) {
        kontostand = kontostand + betrag;
    }

    public void abheben(double betrag) {
        //TODO Bonitaetspruefung
        kontostand = kontostand - betrag;
    }

    public void ueberweisen(double betrag, Konto anderesKonto) {
        this.abheben(betrag);
        anderesKonto.einzahlen(betrag);
    }
    
    public void massenUeberweisung(double betrag, Konto[] andereKonten) {
        for (int i = 0; i < andereKonten.length; i++) {
            this.abheben(betrag);
            andereKonten[i].einzahlen(betrag);
        }
    }

    public String toString() {
        return "Konto(" + this.inhaber + "): " + this.kontostand;
    }

}
