/*
 * $Id: AllTests.java,v 1.1 2005/06/24 13:56:04 boehm Exp $
 *
 * Copyright (c) 2001 Oliver Boehm (mailto:boehm@2xp.de)
 * http://www.2xp.de
 * All rights reserved.
 *
 * -----------------------------------------
 *
 * $Author: boehm $
 * $Date: 2005/06/24 13:56:04 $
 * $Revision: 1.1 $
 *
 * $Log: AllTests.java,v $
 * Revision 1.1  2005/06/24 13:56:04  boehm
 * Einspielen der Beispiele und Uebungen inkl. HTML-Seiten
 *
 * Revision 1.2  2001/12/23 22:54:46  oliver
 * main() added to Player and tested intensiv
 *
 * Revision 1.1  2001/12/22 20:52:23  oliver
 * AllTests added
 *
 * Revision 1.1  2001/12/22 20:02:19  oliver
 * ShotTest object added / Shot extended
 *
 */



package armada.test;



import junit.framework.*;
import junit.swingui.TestRunner;



public class AllTests extends TestCase {



    /**
     * Constructor for AllTests.
     * @param arg0
     */
    public AllTests(String name) {
        super(name);
    }




    /**
     * Method suite
     * @return Test
     */

    public static Test suite() {
        TestSuite suite = new TestSuite(AllTests.class.getName());
        suite.addTest(new TestSuite(BoardTest.class));
        suite.addTest(new TestSuite(ConfigTest.class));
        suite.addTest(new TestSuite(ShotTest.class));
        suite.addTest(new TestSuite(PlayerTest.class));
        return suite;
    }



    /**
     *  The main method is provided if you want to start the tests manually.
     *  <br>
     *  If you want to start the graphical UI type in:
     *  <tt> java junit.ui.TestRunner jrequest.test.AllTests </tt>
     *  If you want the Swing UI instead of the AWT UI use
     *  <tt> junit.swingui.TestRunner </tt>.
     *
     *  @param args	not used
     */

    public static void main(String[] args) {
        //junit.textui.TestRunner.run(suite());
        TestRunner.run(AllTests.class);
    }
}

