package armada.test;

import junit.framework.*;
import armada.*;

/**
 * Title:        Armada
 * Description:  Ein einfaches "Schiffe versenken"-Beispiel
 * Copyright:    Copyright (c) 2001
 * Company:      2XP
 * @author
 * @version 1.0
 */

public class BoardTest extends TestCase {

    public BoardTest(String name) {
        super(name);
    }

    public void testDummy() {
        assertTrue(true | false);
    }

    /**
     *  Method testBoard creates a new board and tests it.
     */
    public void testBoard() {
        Board board = new Board();
        assertTrue("all ships must be intact", board.isHit());
    }
    
    public void testDistribution() {
    	Board board = new Board();
    	Shot shot = new Shot();
        int w = Config.getInstance().getBoardWidth();
        int h = Config.getInstance().getBoardHeight();
    	int n = board.countFreeVerticalFields(shot);
    	assertTrue("must be between 0 and " + h, (n >= 0) && (n <= h));
    	n = board.countFreeHorizontalFields(shot);
    	assertTrue("must be between 0 and " + w, (n >= 0) && (n <= w));
    }
    
    public void testEquals() {
        Board b1 = new Board();
        Board b2 = (Board) b1.clone();
        assertEquals(b1, b2);
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(BoardTest.class);
    }

}
