/*
 * $Id: PlayerTest.java,v 1.1 2005/06/24 13:56:05 boehm Exp $
 *
 * Copyright (c) 2001 Oliver Boehm (mailto:boehm@2xp.de)
 * http://www.2xp.de
 * All rights reserved.
 *
 * -----------------------------------------
 *
 * $Author: boehm $
 * $Date: 2005/06/24 13:56:05 $
 * $Revision: 1.1 $
 *
 * $Log: PlayerTest.java,v $
 * Revision 1.1  2005/06/24 13:56:05  boehm
 * Einspielen der Beispiele und Uebungen inkl. HTML-Seiten
 *
 * Revision 1.3  2001/12/26 10:43:42  oliver
 * class ComputerPlayer added and made Player abstarct
 *
 * Revision 1.2  2001/12/23 20:39:35  oliver
 * Player.turn() implemented
 *
 * Revision 1.1  2001/11/11 17:13:05  oliver
 * jar target added
 *
 */

package armada.test;

import java.io.IOException;

import junit.framework.*;
import armada.*;

public class PlayerTest extends TestCase {

    public PlayerTest(String name) {
        super(name);
    }

    public void testDummy() {
        assertTrue(true);
    }

    public void xxxtestWhichFails() {
        assertTrue("sorry, this test always fails", false);
    }

    public void testGame() {
    	Player player1 = new ComputerPlayer("Tester1");
    	Player player2 = new ComputerPlayer("Tester2");
    	player1.opponent = player2;
    	player2.opponent = player1;
    	for (int i = 0; !player1.gameOver(); i++) {
    	    Shot shot = player1.turn();
    	    assertTrue("too many turns", i < 100);
    	}
    }
    
    public void testPersistence() throws IOException {
        Player player = new ComputerPlayer("T1");
        player.store();
        Player loaded = player.load();
        assertEquals(player, loaded);
    }

    public static void main(String[] args) {
        junit.textui.TestRunner.run(PlayerTest.class);
    }

}
